#ifndef COMPOSITESIMPSON_H
#define COMPOSITESIMPSON_H 1

#include <vector>
#include <cmath>

class CompositeSimpson{

public:
	std::vector<double> points;     // Vector of quadrature points
	std::vector<double> weights;    // Vector of quadrature weights
	    
	int level;                      // Level of the quadrature rule
	
	// Constructor: Should compute the points and weights, sets the level.
    CompositeSimpson(int _level);
	
	// Copy-Constructor: Necessary for assignments of the form
    //      CompositeSimpson a(3);
    //      CompositeSimpson b = a;
    CompositeSimpson(const CompositeSimpson& copy);
	
	// Difference operator: Returns the difference between the current quadrature rule
	// (*this) and the argument rhs.
	CompositeSimpson
    operator-(const CompositeSimpson& rhs);
	
	// Assignment operator: Copies points, weights and level of rule rhs
	CompositeSimpson&
    operator=(const CompositeSimpson& rhs);
	
};

#endif // COMPOSITESIMPSON_H